<script>
// import {
//   BButton,
//   BCard,
//   BCol,
//   BForm,
//   BFormCheckbox,
//   BFormGroup,
//   BFormSelect,
//   BRow,
//   BSpinner,
// } from 'bootstrap-vue'
import UserApiV1 from '@/api/userApi'

export default {
  name: 'SettingGeneral',
  components: {
    BCard,
    BForm,
    BFormSelect,
    BFormCheckbox,
    BRow,
    BCol,
    BFormGroup,
    BButton,
    BSpinner,
  },
  props: {
    userDada: {
      type: Object,
    },
  },
  data() {
    return {
      saving: false,
      event_selected: null,
      event_options: [
        { value: null, text: 'Select an event' },
        { value: 'pipeline_success', text: 'pipeline_success' },
        { value: 'pipeline_failed', text: 'pipeline_failed' },
        { value: 'pipeline_created', text: 'pipeline_created' },
        { value: 'pipeline_deleted', text: 'pipeline_deleted', disabled: true },
      ],
      reporter_selected: ['mail'],
    }
  },
  methods: {
    async saveUser() {
      this.saving = true
      console.log('this.userDada: ', this.userDada)

      const users = new UserApiV1()
      try {
        this.responseUserData = await users.updateUser(this.userDada)
        console.log('responseUserData: ', JSON.parse(JSON.stringify(this.responseUserData.data)))
        this.saving = false
      }
      catch (error) {
        console.log('error getUserById', error)
        this.saving = false
      }
    },
  },
}
</script>

<template>
  <BCard>
    <BForm class="mt-2">
      <BRow>
        <BCol sm="12">
          <BFormGroup
            label="Event"
            label-for="event"
          >
            <BFormSelect
              v-model="event_selected"
              :options="event_options"
              value="mail"
            />
          </BFormGroup>
        </BCol>
        <BCol sm="12">
          <BFormGroup
            label="Reporter"
            label-for="reporter"
          >
            <div class="demo-inline-spacing">
              <BFormCheckbox
                v-model="reporter_selected"
                value="mail"
              >
                Mail
              </BFormCheckbox>
              <BFormCheckbox
                v-model="reporter_selected"
                value="slack"
                disabled
              >
                Slack
              </BFormCheckbox>
              <BFormCheckbox
                v-model="reporter_selected"
                value="teams"
                disabled
              >
                Teams
              </BFormCheckbox>
              <BFormCheckbox
                v-model="reporter_selected"
                value="telegram"
                disabled
              >
                Telegram
              </BFormCheckbox>
              <BFormCheckbox
                v-model="reporter_selected"
                value="gitlab"
                disabled
              >
                GitLab
              </BFormCheckbox>
              <BFormCheckbox
                v-model="reporter_selected"
                value="jira"
                disabled
              >
                Jira
              </BFormCheckbox>
            </div>
          </BFormGroup>
        </BCol>
        <BCol cols="12">
          <BButton
            variant="primary"
            class="mt-2 mr-1"
            :disabled="saving"
            @click="saveUser"
          >
            <BSpinner
              v-if="saving"
              small
            />
            <span v-if="saving"> Saving... </span>
            <span v-else> Save changes </span>
          </BButton>
        </BCol>
      </BRow>
    </BForm>
  </BCard>
</template>

<style scoped>

</style>
